# %rel, %ver, %LSBRelease are defined in the Makefile
%define ver 5.1.5
%define rel 0.20180922.47
%define LSBRelease 5
%define relstring lsb

# WARNING: "Beyond here lie dragons"

# give us a way to do a native build use --with gcc
# or use --without gcc to force lsbcc
# default is gcc now - see bug 2855
%define build_with_lsbcc 0
%{?_with_gcc: %{expand: %%global build_with_lsbcc 0}}
%{?_without_gcc: %{expand: %%global build_with_lsbcc 1}}
%if !%build_with_lsbcc
%endif

# if we build everything with gcc, Xproto, XIproto tests still fall down
# if we use --with gcc and --with xprotolsbcc, we get a "hybrid" build
# gcc, xprotolsbcc are the defaults now - see bug 2855
%define xproto_with_lsbcc 1
%{?_with_xprotolsbcc: %{expand: %%global xproto_with_lsbcc 1}}
%{?_without_xprotolsbcc: %{expand: %%global xproto_with_lsbcc 0}}
%if %xproto_with_lsbcc && !%build_with_lsbcc
%endif 

%if %xproto_with_lsbcc
  # we expect this many build fails from Xproto on the first pass
  %define expected_fails 157
%endif

#(sb) unset this to disable the build fail on 
# compile errors in the build journal (for debugging)
%define no_abort_on_build_fail 0
%{?_with_noabort: %{expand: %%global no_abort_on_build_fail 1}}

# test count for the journal
%define total_tests 4521
# test binary count to insure we have a good build
%define total_binaries 735

Summary: LSB X Window System Test Suite (XTS5)
Name: lsb-test-xts5
Version: %{ver}
Release: %{rel}.%{relstring}%{LSBRelease}
License: MIT
Group: Development/Tools
Source0: xts5-5.1.5.tar.gz
Source1: %{name}-%{version}.tar.gz
Source2: vsw4-evi-tests.tar.gz
Patch0: xts5-5.1.5-lsb-generic.patch
Patch1: xts5-5.1.5-lsb-Xt.patch
Patch2: xts5-5.1.5-lsb-Xlib.patch
Patch3: xts5-5.1.5-lsb-XI.patch
Patch4: xts5-5.1.5-bug-1589.patch
Patch5: xts5-5.1.5-drop-Xt-tests.patch
Patch6: xts5-5.1.5-lsbcc.patch
Patch8: xts5-5.1.5-bug-1906.patch
Patch9: xts5-5.1.5-bug-1937.patch
Patch10: xts5-5.1.5-bug-1991.patch
Patch11: xts5-5.1.5-redefine-NULL.patch
Patch12: xts5-5.1.5-lsbcc2.patch
Patch16: xts5-5.1.5-lsbcc6.patch
Patch17: xts5-5.1.5-clsdsply-bug-2405.patch
Patch18: xts5-5.1.5-lsbcc7.patch
Patch19: xts5-5.1.5-bug-2429.patch
Patch20: xts5-5.1.5-bug-2581.patch
Patch21: xts5-5.1.5-bug-2716.patch
Patch22: xts5-5.1.5-bug-2637.patch
Patch23: xts5-5.1.5-bug-2651.patch
Patch24: xts5-5.1.5-bug-3090.patch
Patch25: xts5-5.1.5-bug-3480.patch

URL: http://www.linuxbase.org/test
BuildRoot: %{_tmppath}/%{name}-root
AutoReqProv: no
Requires: lsb-tet3-lite
Requires: lsb-xvfb >= 1.2.0-19
BuildRequires: lsb-tet3-lite-devel lsb-build-desktop lsb-build-cc
%define	tet_root	%{_libdir}/tet
%define topdir		/opt/lsb/test/xts5

%description
This is the official package version of LSB X Window System test suite.
These tests are derived from the XTS5 test suites.

%package -n %{name}-source
Summary: LSB Desktop Test Suites xts5 Source
Group: Development/Documentation

%description -n %{name}-source
C source files from the lsb-test-xts5 build, for failure debugging

#==================================================
%prep
%if %xproto_with_lsbcc && %build_with_lsbcc
  echo "ABORT: refusing to build --with xprotolsbcc and"
  echo "ABORT: not --with gcc. Just use the default build"
  exit 1
%endif

%setup -c -q -n %{name}-%{version}
tar xzf %{SOURCE1} -C ../
tar xzf %{SOURCE2} -C xts5
# Fix up permissions; some of the tarballs mark stuff read-only.
chmod -R u+w .

%patch0 -p0 -b .lsb-xts5-generic
%patch1 -p0 -b .lsb-xts5-Xt
%patch2 -p0 -b .lsb-xts5-Xlib
%patch3 -p0 -b .lsb-xts5-XI
%patch4 -p0 -b .lsb-1589
%patch5 -p0 -b .drop-Xt-tests

%if %build_with_lsbcc
%patch6 -p0 -b .lsbcc
%endif

%patch8 -p0 -b .bug-1906
%patch9 -p0 -b .bug-1937

%if %build_with_lsbcc
%patch10 -p0 -b .bug-1991
%patch11 -p0 -b .NULL
%patch12 -p0 -b .lsbcc2
%patch16 -p0 -b .lsbcc6
%endif

%patch17 -p0 -b .bug-2405

%if %build_with_lsbcc
%patch18 -p0 -b .lsbcc7
%endif

%patch19 -p0 -b .bug-2429
%patch20 -p0 -b .bug-2581

%if %build_with_lsbcc
# let things build without XInput_find_display (bug 2716)
%patch21 -p1 -b .bug-2716
# something weird with empty files on SLES10, mode 0000
find xts5/src -name '*.lsbcc*' | xargs chmod 0660 
%endif

%patch22 -p0 -b .bug-2637
%patch23 -p0 -b .bug-2651
%patch24 -p0 -b .bug-3090
%patch25 -p0 -b .bug-3480

# Modify kycdtkysym, lkpkysym tests to not use 'index', 
# which is called out in updated LSB strings.h
# turns out these test were silently not building
# fixed the same issue in vsw4 back in July '07
sed -i 's|index|xindex|g' xts5/tset/Xlib17/kycdtkysym/kycdtkysym.m
sed -i 's|index|xindex|g' xts5/tset/Xlib17/lkpkysym/lkpkysym.m

#==================================================
%build
# We want to build with lsbcc. Until that's possible,
# force the LSB dynamic linker so the system under test
# will use the libraries normally used for LSB conformance
LDSO_VERSION=3
%ifarch %{ix86}
LDSO=/lib/ld-lsb.so.$LDSO_VERSION
%endif
%ifarch ppc
LDSO=/lib/ld-lsb-ppc32.so.$LDSO_VERSION
%endif
%ifarch ppc64
LDSO=/lib64/ld-lsb-ppc64.so.$LDSO_VERSION
%endif
%ifarch s390
LDSO=/lib/ld-lsb-s390.so.$LDSO_VERSION
%endif
%ifarch s390x
LDSO=/lib64/ld-lsb-s390x.so.$LDSO_VERSION
%endif
%ifarch ia64
LDSO=/lib/ld-lsb-ia64.so.$LDSO_VERSION
%endif
%ifarch x86_64
LDSO=/lib64/ld-lsb-x86-64.so.$LDSO_VERSION
%endif

# need a scenario for the EVI tests from vsw4
for test in vgtvslinf vqryextnsn vqryvrsn;do
  echo "/tset/EVI/$test/Test" >> xts5/scenarios/EVI_scen
done
sed -i 's|^Interface|EVI\n\t:include:/scenarios/EVI_scen\nInterface|' xts5/tet_scen

# move EVI tests into xts5/tset
mv xts5/xtest/tset/EVI xts5/tset
# mc from xts5 segfaults on vgtvslinf.m - can't figure out why
# build a copy of the vsw4 one to use for the EVI tests
cd xts5/xtest/src/bin/mc
make
cp mc ../../../../bin/mc-vsw4
cd -
cd xts5/xtest
install -d lib/mc
cp -ar src/bin/mc/tmpl/* lib/mc
cd -
# build Test.c from the template using the vsw4 mc
cd xts5/tset/EVI
for test in vgtvslinf vqryextnsn vqryvrsn;do
  cd $test
  TET_ROOT=../../.. ../../../bin/mc-vsw4 -o Test.c $test.m
  cd ..
done
cd ../../..
# back to normal build

%if %no_abort_on_build_fail
sed -i 's|^FAIL_NUM|#FAIL_NUM|' build.sh
%endif

%if %build_with_lsbcc
export LSBCC_BESTEFFORT=1
CC="lsbcc -DX11_t -DTRANS_CLIENT -DUNIXCONN -Wl,-rpath,%{topdir}/xts5/lib"
%else
CC="gcc -DX11_t -DTRANS_CLIENT -DUNIXCONN -Wl,-rpath,%{topdir}/xts5/lib"
%endif

# new LSB X headers wreaking havoc on build, use only LSB headers
# and some selected copies of system headers (bug 2290)
# seem to need both xts5/src/lib and xts5/src/lib/X11 to keep out
# conflicts with the LSB headers
sed -i 's|SYSINC=-I/usr/include/X11 -I/usr/X11R6/include/X11|SYSINC=-I%{_builddir}/%{name}-%{ver}/xts5/src/lib -I%{_builddir}/%{name}-%{ver}/xts5/src/lib/X11|' configs/tetbuild.cfg.skel

# (sb) bug 2429 - building libXst as a shared library, 
# need -fPIC on x86_64, ia64 - just do it on all archs
sed -i 's|CFLAGS=\$(XP_CFLAGS)|CFLAGS=\$(XP_CFLAGS) -fPIC|' xts5/src/libproto/Makefile

%if %xproto_with_lsbcc
chmod 0660 xts5/src/lib/Makefile
cp xts5/src/lib/Makefile xts5/src/lib/Makefile.2429
# we expect the Xproto builds to fail on this first pass, with
# undefined reference to `_XConnectDisplay'
sed -i 's|^FAIL_NUM|FAIL_NUM=0\n#FAIL_NUM|' build.sh
%endif

sed -i 's|\$(CFLAGS) \$<|\$(CFLAGS) -fPIC \$<|' xts5/src/lib/Makefile

CC=${CC} ./build.sh

%if %xproto_with_lsbcc
# we expect some fails from Xproto, but check that there aren't more
sed -i "s|@EXPECTEDFAILS@|%expected_fails|g" check.sh
./check.sh
%endif

%if %build_with_lsbcc
# FIXME (sb) bug 2555
# We've patched build.sh to generate the Makefiles up front and exit 
# before the build. Now we need to patch the Makefiles for the 16 Xlib8
# tests that would be no-builds in our current patch configuration
# so that we build with gcc and -Wl,--dynamic-linker=${LDSO}
for testdir in chnggc cpygc starcmd stbg stclporgn stdshs \
	stfllrl stfllstyl stfnctn stfrgrnd stgrphcsex \
	stlnattrbt stplnmsk stsbwmd ststt sttsorgn;do
  cd xts5/tset/Xlib8/$testdir
  # FIXME (sb) - moblin bug: http://bugzilla.moblin.org/show_bug.cgi?id=5402
  # now moblin says we want to use besteffort and no ld-lsb linker
  #sed -i "s|^SOURCES=|CC=gcc -Wl,--dynamic-linker=${LDSO}\nSOURCES=|" Makefile  
  sed -i "s|^SOURCES=|CC=gcc\nSOURCES=|" Makefile
  cd -
done

head -14 build.sh > testbuild.sh
echo "cd xts5" >> testbuild.sh
tail -23 build.sh >> testbuild.sh
chmod +x testbuild.sh
CC=${CC} ./testbuild.sh
# end bug 2555 FIXME

# FIXME
# (sb) These 3 tests fail when built with lsbcc
# it seems to be keyed to using /opt/lsb/lib/libXt.so at the
# link stage, although I can't put my finger on why.
# Needed symbols are there, link goes fine, but the test
# fails: Xt3/tisvndrshl 1, Xt6/wdgttplvls 9, Xt6/wdgttrnsnt 9
#
# as a workaround, go back and re-link them using the system libXt
# we've disable Xt tests at the moment anyway, so we may be OK
LDFLAGS=`grep '^LDFLAGS\=' xts5/tetbuild.cfg | awk -F\= '{print $2}'`
CC="gcc -o Test Test.o $LDFLAGS /opt/lsb-tet3-lite/lib/tet3/tcm.o "
AR="../../../lib/libxtest.a ../../../lib/libxtestlsbcc.a ../../../lib/libXtTest.a /opt/lsb-tet3-lite/lib/tet3/libapi.a"
%ifarch x86_64 ppc64 s390x
LIB=lib64
%else
LIB=lib
%endif
XAWLIBS="/opt/lsb/$LIB/libXaw.a /opt/lsb/$LIB/libXmu.a /opt/lsb/$LIB/libXpm.a"
XLIBS="/usr/X11R6/$LIB/libXtst.a /opt/lsb/$LIB/libXext.so /opt/lsb/$LIB/libX11.so"
LINKER="-Wl,--dynamic-linker=${LDSO}"
LSBLIBS="/opt/lsb/$LIB/libc.so /opt/lsb/$LIB/libpthread.so /opt/lsb/$LIB/libm.so /opt/lsb/$LIB/libdl.so /opt/lsb/$LIB/libICE.so /opt/lsb/$LIB/libSM.so -lc_nonshared"
# hmm, we get glibc 2.4 symbol issues at link on ppc64 using the above
LSBLIBS="/opt/lsb/$LIB/libICE.so /opt/lsb/$LIB/libSM.so"

%if 0
cd xts5/tset/Xt3/tisvndrshl
$CC $AR $XAWLIBS $XLIBS -lXt $LINKER $LSBLIBS
cd ../..
for DIR in Xt6/wdgttplvls Xt6/wdgttrnsnt;do
  cd $DIR
  $CC $AR $XLIBS -lXt $LINKER $LSBLIBS
  cd ../..
done
cd ../..
%endif #if 0
%endif #build_with_lsbcc

%if %xproto_with_lsbcc
# (sb) If we build everything with gcc, we can actually get almost a
# full set of tests running on Rawhide. Exceptions are the Xproto tests
# and most XIproto tests. Go back and rebuild these with lsbcc.
# see bug 2716

# but, since we bypassed all the lsbcc patches, now the static archive 
# files are missing symbols, like _xib*, _XConnectDisplay
# go back and apply the patches, then rebuild the harness and the tests

# put this back so the patches will apply
cp xts5/src/lib/Makefile.2429 xts5/src/lib/Makefile
patch -p0 < %{PATCH6}
patch -p0 < %{PATCH10}
patch -p0 < %{PATCH11}
patch -p0 < %{PATCH12}
patch -p0 < %{PATCH16}
patch -p0 < %{PATCH18}

# this one is *only* for the hybrid build - things blow up if we try to
# use it for the normal build - trying not to rely on XInput_find_display
patch -p1 < %{PATCH21}

# then modify the Makefile again
sed -i 's|\$(CFLAGS) \$<|\$(CFLAGS) -fPIC \$<|' xts5/src/lib/Makefile

# now we just want to build Xproto and XIproto
# but, we need to regenerate the Makefiles, and remove the .o

for DIR in Xproto XIproto EVI;do
  find xts5/tset/$DIR -name Makefile | xargs rm -f
  find xts5/tset/$DIR -name Test.o | xargs rm -f
done

# P18 puts this in, back it off
sed -i 's|^exit 0|#exit 0|' build.sh

# modify build.sh to just build a subset
sed -i "s|tcc -b -p xts5 all|tcc -b -p xts5 Xproto\ntcc -b -p xts5 XIproto\ntcc -b -p xts5 EVI|" build.sh

# fix SYSINC again
sed -i 's|SYSINC=-I/usr/include/X11 -I/usr/X11R6/include/X11|SYSINC=-I%{_builddir}/%{name}-%{ver}/xts5/src/lib -I%{_builddir}/%{name}-%{ver}/xts5/src/lib/X11|' configs/tetbuild.cfg.skel

# this is left behind from the previous run
rm -fr xts5/lib/archive
# 2/14/12 (sb) after resurrecting the build systems, we're falling down on 
# blowup - ajax.o from the first run, built with gcc is left and link fails
rm -f xts5/src/pixval/blowup/ajax.o

export LSBCC_BESTEFFORT=1
CC="lsbcc -DX11_t -DTRANS_CLIENT -DUNIXCONN -Wl,-rpath,%{topdir}/xts5/lib"

# we expect the build to succeed now
sed -i 's|^#FAIL_NUM|FAIL_NUM|' build.sh

# and build
CC=${CC} ./build.sh

%endif #%xproto_lsbcc

# patch tet_scen after we build, otherwise Xt tests don't build either
# (sb) moved this back earlier so we don't build/ship (smaller package)
#patch -p0 -b -z .drop-Xt-tests < %{PATCH5}

# need test counts in tet_scen
sed -i 's|^all|all\n\t"total tests in xts5 %{total_tests}"|' xts5/tet_scen
# strip the EVI label we added for the rebuild or the tests don't run
sed -i 's|^EVI||g' xts5/tet_scen

# after all that, we can still have a bad build due to key system -devel
# packages being missing (bug 3245, 3247)
for log in `ls xts5/results/install.log*`;do
  errors=`grep -ch 'Error 1' $log || true`
  if [ "$errors" -ne 0 ];then
    echo "Portions of the build failed, please see $log"
    exit 1
  fi
done

# just for good measure, count the "Test" binaries
totaltests=`find . -name Test | wc -l`
if [ "$totaltests" -ne %{total_binaries} ];then
  echo "not enough 'Test' binaries, expected %{total_binaries}"
  exit 1
fi

#==================================================
%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{topdir}
mkdir -p ${RPM_BUILD_ROOT}%{topdir}/xts5/fonts
mkdir -p ${RPM_BUILD_ROOT}/opt/lsb/doc/%{name}

# move the old %%post message to a README
cat > README.%{name} << EOF
To run the tests, please execute the following command:
    cd /opt/lsb/test/lsb-xts5; ./run_xts5.sh
EOF

# change the XT_FONTDIR and XT_FONTPATH preparing for install
TET_ROOT=`pwd`
cp -f configs/tetbuild.cfg.skel xts5/tetbuild.cfg
cp -f configs/tetexec.cfg.skel xts5/tetexec.cfg
cp -f xts5/tetexec.cfg xts5/tetexec.cfg.old
sed -e "s\\^XT_FONTDIR=\\XT_FONTDIR=%{topdir}/xts5/fonts\\" \
    -e "s\\^XT_FONTPATH=\\XT_FONTPATH=%{topdir}/xts5/fonts,\\" \
xts5/tetexec.cfg > xts5/tetexec.cfg.new
sed -i "s\\/usr/X11R6/lib/X11/fonts/misc\\/opt/lsb/share/fonts/misc\\" xts5/tetexec.cfg.new
sed -i "s\\/usr/lib/X11/fonts/100dpi/\\/opt/lsb/share/fonts/100dpi/\\" xts5/tetexec.cfg.new
sed -i "s\\/usr/lib/X11/fonts/75dpi/\\/opt/lsb/share/fonts/75dpi/\\" xts5/tetexec.cfg.new
mv -f xts5/tetexec.cfg.new xts5/tetexec.cfg

for testcase in mbdstr wcdstr wcdtext
do
    cp xts5/tset/Xlib14/$testcase/a1.C.dat xts5/tset/Xlib14/$testcase/a1.en_US.ISO8859-1.dat
done

# correct the BUILD_VERSION setting in run_xts5.sh
cat > change_version.sh << EOF
sed -e "s@BUILD_VERSION=@BUILD_VERSION=\"${RPM_PACKAGE_VERSION}-${RPM_PACKAGE_RELEASE} ($RPM_ARCH)\"@" run_xts5.sh \
       > ${RPM_BUILD_ROOT}%{topdir}/run_xts5.sh
EOF
chmod a+x change_version.sh && ./change_version.sh && rm -f change_version.sh
cp ${RPM_BUILD_ROOT}%{topdir}/run_xts5.sh run_xts5.sh

# install License, README and run_xts5.sh
cp -prf run_xts5.sh ${RPM_BUILD_ROOT}%{topdir} 
cp -prf License README README.%{name} ${RPM_BUILD_ROOT}/opt/lsb/doc/%{name}
chmod +x ${RPM_BUILD_ROOT}%{topdir}/run_xts5.sh

# install fonts
cp -prf xts5/fonts/xtfont*.pcf* ${RPM_BUILD_ROOT}%{topdir}/xts5/fonts
( cd ${RPM_BUILD_ROOT}%{topdir}/xts5/fonts && mkfontdir )

cd xts5
find bin configs lib scenarios tet_code tetexec.cfg tet_scen tet_tmp_dir man doc -print | cpio -pdv ${RPM_BUILD_ROOT}%{topdir}/xts5

rsync -aH --exclude="*.[o|h|m|c]" --exclude="*.m.bug*" --exclude="*.lsb*" --exclude="Makefile" --exclude="*asserts" --exclude="*.err" --exclude="tet*" tset ${RPM_BUILD_ROOT}%{topdir}/xts5

# why did we include these .a files and things in the first place?
rm -f ${RPM_BUILD_ROOT}%{topdir}/xts5/lib/*.a
rm -fr ${RPM_BUILD_ROOT}%{topdir}/xts5/lib/{archive,error,gc,mc}

# we need to define this at run time, not build time
rm -f ${RPM_BUILD_ROOT}%{topdir}/xts5/tset/Xlib17/gtdflt/.Xdefaults-`hostname`

# so any user can save results
install -d ${RPM_BUILD_ROOT}%{topdir}/xts5/results
chmod 0777 ${RPM_BUILD_ROOT}%{topdir}/xts5/results
# for .configured
install -d ${RPM_BUILD_ROOT}%{topdir}/lock
chmod 0777 ${RPM_BUILD_ROOT}%{topdir}/lock
# run_xts5.sh writes to this
chmod 0666 ${RPM_BUILD_ROOT}%{topdir}/xts5/fonts/fonts.dir
# so any user can setup the config from run_xts5.sh
chmod 0777 ${RPM_BUILD_ROOT}%{topdir}/xts5
chmod 0666 ${RPM_BUILD_ROOT}%{topdir}/xts5/tetexec.cfg

# xts5 c source
mkdir ${RPM_BUILD_ROOT}/opt/lsb/doc/%{name}/lsb-xts5-source
find tset -name 'Test.c' | xargs -i cp --parents {} ${RPM_BUILD_ROOT}/opt/lsb/doc/%{name}/lsb-xts5-source

#==================================================
%clean
# uncomment later. leave in now for speed
if [ ! -z "${RPM_BUILD_ROOT}"  -a "${RPM_BUILD_ROOT}" != "/" ]; then 
    rm -rf ${RPM_BUILD_ROOT}
fi


#======================================================================
%post
rm -f %{topdir}/lock/.configured > /dev/null 2>&1

#==================================================
%files
%defattr(-,root,root)
%config(noreplace) %{topdir}/xts5/tetexec.cfg

%{topdir}/xts5
%{topdir}/run_xts5.sh

%dir %{topdir}
%dir %{topdir}/lock
%dir /opt/lsb/doc/%{name}
/opt/lsb/doc/%{name}/README
/opt/lsb/doc/%{name}/README.lsb-test-xts5
/opt/lsb/doc/%{name}/License

%files -n %{name}-source
%defattr(-,root,root)
%dir /opt/lsb/doc/%{name}/lsb-xts5-source
/opt/lsb/doc/%{name}/lsb-xts5-source/*

#==================================================
%changelog
* Mon Feb 11 2013 Stew Benedict <stewb@linux-foundation.org>
- EVI tests don't build on Centos6 due to upstream header
  changes, build them with lsbcc again

* Wed Jan 30 2013 Stew Benedict <stewb@linux-foundation.org>
- disable Xlib7/qryclrs/Test 2 (bug 3480, P25)

* Wed May 25 2011 Stew Benedict <stewb@linux-foundation.org>
- make sure we have a complete build (bugs 3245, 3247)

* Thu May 05 2011 Stew Benedict <stewb@linux-foundation.org>
- drop Xlib7/cmsadfs Xlib7/cmsacs - fixed Ubuntu issue but tests
  don't work elsewhere (bug 3090)

* Thu Dec 02 2010 Stew Benedict <stewb@linux-foundation.org>
- build Xlib7/cmsadfs Xlib7/cmsacs with lsbcc also (bug 3090)

* Tue Aug 17 2010 Stew Benedict <stewb@linux-foundation.org>
- disable Xlib3/cnnctnnmbr/Test,MTest (bug 2637)
  disable Xlib12/stioerrrhn/Test 1,7 (bug 2651)
  fix source vs test packaging (source was in both)

* Thu Dec 10 2009 Stew Benedict <stewb@linux-foundation.org>
- add a xts5-source package build (bug 2594)

* Mon Sep 28 2009 Stew Benedict <stewb@linux-foundation.org>
- enable a hybrid build mode --with gcc and --with xprotolsbcc (bug 2716)

* Tue Sep 22 2009 Stew Benedict <stewb@linux-foundation.org>
- add a %%build_with_lsbcc conditional so we can do native builds on demand
- use rpmbuild --with gcc -bb lsb-test-xts5.spec

* Wed May 06 2009 Stew Benedict <stewb@linux-foundation.org>
- fix Xlib12/sndevnt part of bug 2581 (P20)
- don't package the patch backup files

* Wed Apr 29 2009 Stew Benedict <stewb@linux-foundation.org>
- re-do P16, need our own XInput.h now too with updated LSB headers

* Mon Mar 09 2009 Stew Benedict <stewb@linux-foundation.org>
- shrink package size using shared libs and dropping Xt tests (P19, bug 2429)

* Thu Mar 05 2009 Stew Benedict <stewb@linux-foundation.org>
- rework lsbcc patches/stubs to address test SIGSEGV
  on some systems (P18, bug 2555)
- fall back to gcc for 16 Xlib8 tests that either don't build
  with the new arrangement or SIGSEGV with the old

* Wed Feb 25 2009 Stew Benedict <stewb@linux-foundation.org>
- fix spec file issue with %%patch (bug 2537)
 
* Tue Feb 24 2009 Stew Benedict <stewb@linux-foundation.org>
- Add test count to tet_scen (bug 2557)

* Mon Jan 12 2009 Stew Benedict <stewb@linux-foundation.org>
- fix issue with Xlib3/clsdsply/Test 6 on xcb systems (bug 2405, P17)

* Mon Oct 13 2008 Stew Benedict <stewb@linux-foundation.org>
- fix SISEGV issues on 64bit platforms (rediff P11,P16)

* Thu Sep 18 2008 Stew Benedict <stewb@linux-foundation.org>
- forward port EVI tests from vsw4 (S2, bug 1650)

* Tue Sep 16 2008 Stew Benedict <stewb@linux-foundation.org>
- rework bundled headers and add selected patches to build
  with LSB X headers (add P16, drop P13,14,15, bug 2290)

* Thu Sep 11 2008 Stew Benedict <stewb@linux-foundation.org>
- try to catch harness build failures and abort early there

* Fri Sep 05 2008 Stew Benedict <stewb@linux-foundation.org>
- alter SYSINC in tetbuild.cfg to use /opt/lsb/include/X11 
  instead of /usr/include/X11 and /usr/X11R6/include
- pull in more private X headers to deal with expanded LSB headers 
  (P13, bug 2290) and the fact we're not using system includes
- and another set of private X headers (P14, bug 2290)

* Fri Jun 20 2008 Stew Benedict <stewb@linux-foundation.org>
- fix UNREPORTED issue with XI/chgfctl/Test 4
  on s390x, ppc64 (bug 2116)

* Wed May 21 2008 Stew Benedict <stewb@linux-foundation.org>
- Drop P7, we now have libXtst, and build everything with a smaller
  libxtestlsbcc.a. Use additional libxtcsm.a and libxtwdgt.a
  for the few tests that need additional symbols. (P12)

* Thu Mar 13 2008 Stew Benedict <stewb@linux-foundation.org>
- fix issues with missing includes (bug 1991, P10, rediff P6)
- fix issues with NULL being redefined (P11)
- drop /usr/include from SYSINC in tetbuild.cfg.skel (rediff P6)

* Thu Feb 21 2008 Stew Benedict <stewb@linux-foundation.org>
- move from /opt/lsb/test/lsb-xts5 to /opt/lsb/test/xts5 (bug 1938)
- move %%post message to README.%{name} (bug 1940)
- move License, docs to /opt/lsb/doc/%{name}

* Tue Feb 12 2008 Stew Benedict <stewb@linux-foundation.org>
- fix UNREPORTED issues with Xlib4/stwdwbgpxm 7,8 
  on some platforms (bug 1937, P9)

* Tue Jan 29 2008 Stew Benedict <stewb@linux-foundation.org>
- handle behavior change with XSizeHints structure 
  (flags needs to reflect the set of values to change, bug 1906, P8)

* Mon Jan 28 2008 Stew Benedict <stewb@linux-foundation.org>
- create tset/Xlib17/gtdflt/.Xdefaults-`hostname` at runtime,
  not build time (bug 1915)

* Thu Jan 24 2008 Stew Benedict <stewb@linux-foundation.org>
- Build/use alternate test binaries for some Xlib4, Xlib13
  tests that fail to run on xcb based systems (bug 1902, P7)

* Mon Jan 07 2008 Stew Benedict <stewb@linux-foundation.org>
- Modify kycdtkysym, lkpkysym tests to not use 'index'
  which is called out in updated strings.h (were not getting built)

* Tue Oct 30 2007 Stew Benedict <stewb@linux-foundation.org>
- add P6 to build with lsbcc (bug 1529) 
- use a workaround for the 3 remaining regressions
  (Xt tests, disabled in previous revision anyway)
- patch tet_scen (P5) after we build so Xt tests build

* Tue Oct 30 2007 Stew Benedict <stewb@linux-foundation.org>
- disable Xt tests in the "all" scenario (Bug 1371, P5)

* Fri Oct 19 2007 Stew Benedict <stewb@linux-foundation.org>
- change tests so any user can run them
  (copy directory structure to a tmp dir and symlink the tests)
- move the version/release stuff to the Makefile only

* Tue May 15 2007 Stew Benedict
- rediff P0
- split P0 into P0,P1,P2,P3 (generic, Xt, Xlib, XI)
- exclude the patch backup files
- add P4 for #1589 (BadMatch vs BadValue for crtclrmp)

* Thu Jun 23 2005 Rui Feng <fengrui@cn.ibm.com>
- And files into final package

* Mon Jun 20 2005 Rui Feng <fengrui@cn.ibm.com>
- Initial checkin 
